//--------------------------------------------------------------
// Alex A. Trubetskoy             January 2005
//--------------------------------------------------------------
#include "stdafx.h"
#include "SelectEmail.h"
#include "SelectEmailDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSelectEmailDlg dialog

CSelectEmailDlg::CSelectEmailDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSelectEmailDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSelectEmailDlg)
	m_edtPath = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	anchorCreated = false;
}

void CSelectEmailDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSelectEmailDlg)
	DDX_Control(pDX, IDC_LB_RES, mc_lbRes);
	DDX_Text(pDX, IDC_EDT_PATH, m_edtPath);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSelectEmailDlg, CDialog)
	//{{AFX_MSG_MAP(CSelectEmailDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_SIZE()
	ON_WM_CREATE()
	ON_COMMAND(ID_ACTION_SCAN, OnActionScan)
	ON_COMMAND(ID_FILE_SAVEAS, OnFileSaveas)
	ON_BN_CLICKED(IDC_BTN_PATH, OnBtnPath)
	ON_EN_CHANGE(IDC_EDT_PATH, OnChangeEdtPath)
	ON_COMMAND(ID_HELP_ABOUT, OnHelpAbout)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSelectEmailDlg message handlers

BOOL CSelectEmailDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	pAnchor = new CAnchor((CDialog*)this);
	pAnchor->setAnchor(IDC_EDT_PATH, TRUE, TRUE, FALSE, TRUE);
	pAnchor->setAnchor(IDC_LB_RES, TRUE, TRUE, TRUE, TRUE);
	pAnchor->setAnchor(IDC_BTN_PATH, TRUE, FALSE, FALSE, TRUE);
	pAnchor->setAnchor(IDC_GROUP, TRUE, TRUE, TRUE, TRUE);
	anchorCreated = true;
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSelectEmailDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSelectEmailDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSelectEmailDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CSelectEmailDlg::OnTbExit() 
{
	// TODO: Add your command handler code here
	//Close();
}

void CSelectEmailDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	
	// TODO: Add your message handler code here
	if(anchorCreated)
		pAnchor->resize();
}

int CSelectEmailDlg::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CDialog::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: Add your specialized creation code here
	if (!m_toolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_toolBar.LoadToolBar(IDR_TOOLBAR))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}
	m_toolBar.MoveWindow(10, 0, 125, 25);
	
	//set tooltips for the toolbar
	m_toolTips.Create(&m_toolBar);
	CRect Rect;
	m_toolBar.GetToolBarCtrl().GetRect(ID_ACTION_SCAN, Rect);
	m_toolTips.AddTool(&m_toolBar, "Scan", Rect, ID_ACTION_SCAN);
	m_toolBar.GetToolBarCtrl().GetRect(ID_FILE_SAVEAS, Rect);
	m_toolTips.AddTool(&m_toolBar, "Save the result", Rect, ID_FILE_SAVEAS);
	m_toolBar.GetToolBarCtrl().GetRect(ID_HELP_ABOUT, Rect);
	m_toolTips.AddTool(&m_toolBar, "About the program", Rect, ID_HELP_ABOUT);
	m_toolBar.GetToolBarCtrl().GetRect(IDCANCEL, Rect);
	m_toolTips.AddTool(&m_toolBar, "Exit the program", Rect, IDCANCEL);
	//
	m_toolBar.GetToolBarCtrl().SetToolTips(&m_toolTips);

	return 0;
}

void CSelectEmailDlg::OnActionScan() 
{
	UpdateData();
	// TODO: Add your command handler code here
	if(m_edtPath.GetLength() == 0) {
		AfxMessageBox("Enter the file name!");
		return;
	}

	CString fileName = m_edtPath;             //the input_file name
	CString dir;
	int slash = fileName.ReverseFind('\\');
	if(slash == -1) 
		dir.Empty();
	else {
		dir = fileName.Left(slash+1);     //get the directory for output file
	}

	CString text, addr;
	CStdioFile fin;
	bool valid;                            //if the address is valid
	int prevDelimiter, curDelimiter, sign, dot;        //delimiters, @ and .
    if(!fin.Open(fileName, CFile::modeRead | CFile::typeText)) {
		AfxMessageBox("The file doesn't exist!");
		return;
	}
	else {
		while (fin.ReadString(text)) {
			prevDelimiter = curDelimiter = 0;
			//search valid addresses
		    do {                             
				valid = true;
                prevDelimiter = curDelimiter;
				while(prevDelimiter < text.GetLength() &&
					 !admissibleLetter(text[prevDelimiter++]));
				curDelimiter = prevDelimiter;
				while(curDelimiter < text.GetLength() &&
					 admissibleLetter(text[curDelimiter++]));

			    sign = text.Find('@', prevDelimiter);
			    if(sign == -1 || sign >= curDelimiter-2) valid = false;
				dot = text.Find('.', sign);
				if(dot == -1 || dot >= curDelimiter-2) valid = false;
				
				//put the valid address to the list box
				if(valid) {                 
					if(curDelimiter == text.GetLength()) ++curDelimiter;
				    addr = text.Mid(prevDelimiter-1, curDelimiter-prevDelimiter);
					for(int i = 0; i < addr.GetLength(); ++i) {
						if(!admissibleLetter(addr[i])) {
							valid = false;
							break;
						}
					}
					if(valid) {
						if(mc_lbRes.FindString(-1, (LPCTSTR)addr) == LB_ERR)
							mc_lbRes.AddString(addr);
					}
				}
            } while(curDelimiter < text.GetLength());
			text.Empty();
		}
		fin.Close();                      
	}
	UpdateData(FALSE);
}

//the function check if the letter is admissible
bool CSelectEmailDlg::admissibleLetter(char c) {     
	if(isalpha((int)c)) return true;
	else 
	if(c == '.' || c=='-' || c == '_' || c == '@') return true;
	else 
	if(c >= '0' && c <= '9') return true;
	return false;
}

void CSelectEmailDlg::OnFileSaveas() 
{
	// TODO: Add your command handler code here
	CStdioFile fout;
	CString path, temp;
	CFileDialog saveDlg(FALSE, NULL, NULL, 
		             OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
					 "Any file (*.*)|*.*||");
	if(saveDlg.DoModal() == IDOK) {
		path = saveDlg.GetPathName();
		
		if(!fout.Open(path, CFile::modeCreate | 
			CFile::modeWrite | CFile::typeText)) 
		{
			AfxMessageBox("Couldn't create the file\n");
			return;
		} 
		
		//write addresses to the file
		for(int i = 0; i < mc_lbRes.GetCount(); ++i) {
			mc_lbRes.GetText(i, temp);
			fout.WriteString(temp + '\n');
		}
	    fout.Close();
    }
}

void CSelectEmailDlg::OnBtnPath() 
{
	// TODO: Add your control notification handler code here
	CFileDialog openDlg(TRUE, NULL, NULL, 
		             OFN_FILEMUSTEXIST,
					 "Any file (*.*)|*.*||");
	if(openDlg.DoModal() == IDOK) {
		mc_lbRes.ResetContent();
		m_edtPath = openDlg.GetPathName();
		UpdateData(FALSE);
    }
}

void CSelectEmailDlg::OnChangeEdtPath() 
{
	// TODO: Add your control notification handler code here
	mc_lbRes.ResetContent();
}

void CSelectEmailDlg::OnHelpAbout() 
{
	// TODO: Add your command handler code here
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}
