//--------------------------------------------------------------
// Alex A. Trubetskoy             January 2005
//--------------------------------------------------------------

#if !defined(AFX_SELECTEMAILDLG_H__95FDC961_033A_4862_800E_B1B84539CD04__INCLUDED_)
#define AFX_SELECTEMAILDLG_H__95FDC961_033A_4862_800E_B1B84539CD04__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <afxext.h>
#include "AnchorData.h"

/////////////////////////////////////////////////////////////////////////////
// CSelectEmailDlg dialog

class CSelectEmailDlg : public CDialog
{
	CToolBar m_toolBar;
	CToolTipCtrl m_toolTips;
	CAnchor* pAnchor;
	bool anchorCreated;

	bool admissibleLetter(char c);

// Construction
public:
	CSelectEmailDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CSelectEmailDlg)
	enum { IDD = IDD_SELECTEMAIL_DIALOG };
	CListBox	mc_lbRes;
	CString	m_edtPath;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSelectEmailDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CSelectEmailDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnTbExit();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnActionScan();
	afx_msg void OnFileSaveas();
	afx_msg void OnBtnPath();
	afx_msg void OnChangeEdtPath();
	afx_msg void OnHelpAbout();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SELECTEMAILDLG_H__95FDC961_033A_4862_800E_B1B84539CD04__INCLUDED_)
